﻿
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Java.Lang;
using System.Threading;
using Java.Util;
using Com.Rscja.Deviceapi;
using Android.Graphics;


namespace xm_Fingerpint
{
	[Activity (Label = "get")]			
	public class set : Activity
	{

		EditText ID;
		EditText Name;
		ImageView img;
		Button btn;
		RadioButton rbtndef;
		RadioButton rbtniso;
		CheckBox chb;
		TextView labmsg;
		ProgressDialog progressDialog;
		System.Threading.Thread  thread;
		protected override void OnCreate (Bundle bundle)
		{
			base.OnCreate (bundle);
			SetContentView (Resource.Layout.Set);
			// Create your application here

			InitView ();
		}
		void InitView()
		{
			ID = FindViewById<EditText> (Resource.Id.seteditid);
			Name = FindViewById<EditText> (Resource.Id.seteditname);
			img = FindViewById<ImageView> (Resource.Id.setImg);
			btn = FindViewById<Button> (Resource.Id.setbtn);
			rbtndef = FindViewById<RadioButton> (Resource.Id.rbtndef);
			rbtniso = FindViewById<RadioButton> (Resource.Id.rbtniso);
			chb = FindViewById<CheckBox> (Resource.Id.checkBox1);
			labmsg = FindViewById<TextView> (Resource.Id.setlabmsg);
			btn.Click += new EventHandler (delegate {
				Set();
			});

		}

		void Set()
		{
			string pageid = ID.Text.Trim ();
			string name = Name.Text.Trim ();
			bool isshow = false;
			bool isdef = false;
			if (rbtndef.Checked)
				isdef = true;
			else
				isdef = false;
			isshow = chb.Checked;

			if (string.IsNullOrEmpty (pageid)) {

				labmsg.Text = GetString (Resource.String.inputdata);
				return;
			}

			if (!PubClass.isHexNumberRex (pageid)) {

				labmsg.Text = GetString (Resource.String.intputnum);
				return;
			}
			if (string.IsNullOrEmpty (name)) {

				labmsg.Text = GetString (Resource.String.inputdata);
				return;
			}


			if (int.Parse(pageid) < 0 || int.Parse(pageid)> 1000) {

				labmsg.Text = GetString (Resource.String.inputidfw);
				return;
			}


			progressDialog = ProgressDialog.Show(this,
				"", "Doing", true, false);
			progressDialog.SetCancelable(true);
			new System.Threading.Thread(() =>
				{
					this.RunOnUiThread(() =>
						{

							int re=run(isdef,int.Parse (pageid),name,isshow);
							if(re==0)
							{
								labmsg.Text=GetString (Resource.String.setbtnsucc);
								ID.Text="";
								Name.Text="";
								chb.Checked=false;
								if(isshow)
								{

									Bitmap bitmap = BitmapFactory.DecodeFile(
										Android.OS.Environment.ExternalStorageDirectory.ToString ()+ "/finger.bmp");
									img.SetImageBitmap(bitmap);
								
								}
							}
							else if(re==-1)
							{
								labmsg.Text=GetString (Resource.String.getimageFail);
							}
							else if(re==1)
							{
								labmsg.Text=GetString (Resource.String.getimage1);
							}
							else if(re==2)
							{
								labmsg.Text=GetString (Resource.String.getimage2);
							}
							else if(re==3)
							{
								labmsg.Text=GetString (Resource.String.getimagehb);
							}
							else if(re==4)
							{
								labmsg.Text=GetString (Resource.String.getimagesave);

							}
							else if(re==5)
							{

								labmsg.Text=GetString (Resource.String.getimageup);
							}
							progressDialog.Dismiss();
						});
				}).Start();



		}

		/// <summary>
		/// 0 success
		/// </summary>
		/// <param name="isdef">Isdef.</param>
		/// <param name="id">Identifier.</param>
		/// <param name="name">Name.</param>
		/// <param name="isshowimg">If set to <c>true</c> isshowimg.</param>
		int run(bool isdef,int id,string name,bool isshowimg)
		{
			string data1;
			// 采集指纹
			if (!PubClass.fp.Image) {
				return -1;
			}
			// 生成特征值到B1
			if (!PubClass.fp.GenChar (Fingerprint.BufferEnum.B1)) {
				return 1;
			}
			// 再次采集指纹
			if (!PubClass.fp.Image) {
				return -1;
			}
			// 生成特征值到B2
			if (!PubClass.fp.GenChar (Fingerprint.BufferEnum.B2)) {
				return 2;
			}
			// 合并两个缓冲区到B1
			if (!PubClass.fp.RegModel ()) {
				return 3;
			}

			if (PubClass.fp.StorChar (Fingerprint.BufferEnum.B1,id)) {

					// 判断是否定制模块
				if (!isdef) {
					data1 = PubClass.fp.UpChar(Fingerprint.BufferEnum.B11);
					} else {
					data1 = PubClass.fp.UpChar(Fingerprint.BufferEnum.B1);
					}
				PubClass.saveLog (id + "_" + name + "_" + DateTime.Now.ToString ("yyyyMMddHHmmss")+".txt", data1);
				if (isshowimg) {
					// 显示指纹图片
					if (PubClass.fp.Image) {


						if (PubClass.fp.UpImage (1, Android.OS.Environment.ExternalStorageDirectory.ToString ()+ "/finger.bmp") != -1) {
						
							return 0;

						} else {
							return 5;
						}

					} else {
						return -1;
					}
				} else
					return 0;
				}
			else{return 4;}

			

		
		}

	}
}

